# CheapZombie release 5 by David Bowland
# ./addons/eventscripts/cheapzombie/cheapzombie.py

# >>> To configure this addon please see cheapzombie.cfg (created whent he addon is first loaded) <<<

"""
Provides zombie-style gameplay, including admin menu, with only ES 2.0+
"""


import cfglib
import es
import gamethread
import langlib
import os.path
import playerlib
import random
import services

import psyco
psyco.full()


info = es.AddonInfo()
info.name     = 'CheapZombie'
info.version  = '5'
info.basename = 'cheapzombie'
info.url      = 'http://addons.eventscripts.com/addons/view/' + info.basename
info.author   = 'SuperDave'


###


config = cfglib.AddonCFG(es.getAddonPath(info.basename) + '/' + info.basename + '.cfg')

config.text(info.name + ' release %s options' % info.version)
config.text('./addons/eventscripts/%(basename)s/%(basename)s.cfg' % {'basename':info.basename})
config.text(info.url)
config.text('')
config.text('Load this addon with: es_load ' + info.basename)
config.text('\n')
config.text('To configure language settings for %s please see %s_languages.ini' % (info.name, info.basename))
config.text('\n')
config.text('DO NOT use mp_restartgame or endround while CheapZombie is loaded.')
config.text('Likewise, do not add or remove bots (bot_quota, bot_quota_mode, bot_add, bot_kick, etc.).')
config.text('CheapZombie requires at least two living players (including bots) to start a zombie round.')
config.text('\n')
config.text('To add background music that changes based on what is happening in the game, see:')
config.text('http://addons.eventscripts.com/addons/view/cssoundtrack')
config.text('')
config.text('To add fog to maps that changes based on the location of players, see:')
config.text('http://addons.eventscripts.com/addons/view/teamfog')
config.text('\n')

config.text('***** Human options *****')
cvar_human_health             = config.cvar('cheapzombie_human_health',             100,                               'Starting health of humans')
cvar_human_handgun            = config.cvar('cheapzombie_human_handgun',            'deagle;usp;fiveseven;p228;glock', 'Starting handgun of humans separated by a semicolon--set to \"none\" for no change')
cvar_human_bot_removehe       = config.cvar('cheapzombie_human_bot_removehe',       1,                                 '0 = no change, 1 = remove HE grenades from bots')
cvar_human_spawn_cash         = config.cvar('cheapzombie_human_spawn_cash',         1500,                              'Amount of cash players receive at the start of each round')
cvar_human_laststanding_score = config.cvar('cheapzombie_human_laststanding_score', 5,                                 'Number of points the last living human player receives for killing all zombies')
cvar_human_laststanding_cash  = config.cvar('cheapzombie_human_laststanding_cash',  8000,                              'Amount of cash the last living human player receives for killing all zombies')
config.text('\n')

config.text('***** Zombie options *****')
config.text('')
config.text('  *** Zombie creation options ***')
cvar_zombie_initialdelay_min = config.cvar('cheapzombie_zombie_initialdelay_min', 5,   'Minimum number of seconds after round start zombies will appear')
cvar_zombie_initialdelay_max = config.cvar('cheapzombie_zombie_initialdelay_max', 25,  'Maximum number of seconds after round start zombies will appear')
cvar_zombie_delay_min        = config.cvar('cheapzombie_zombie_delay_min',        3,   'Minimum number of seconds after all zombies are dead new zombies will appear')
cvar_zombie_delay_max        = config.cvar('cheapzombie_zombie_delay_max',        15,  'Maximum number of seconds after all zombies are dead new zombies will appear')
cvar_zombie_percent_min      = config.cvar('cheapzombie_zombie_percent_min',      30,  'Minimum percent of human players to turn zombie when zombies appear')
cvar_zombie_percent_max      = config.cvar('cheapzombie_zombie_percent_max',      70,  'Maximum percent of human players to turn zombie when zombies appear')
cvar_zombie_bothandicap      = config.cvar('cheapzombie_zombie_bothandicap',      200, 'Amount of damage to handicap bots when picking zombies--set to -1 to always pick bots before humans')
cvar_zombie_create_score     = config.cvar('cheapzombie_zombie_create_score',     2,   'Number of points zombies receive for turning a human to a zombie')
cvar_zombie_create_cash      = config.cvar('cheapzombie_zombie_create_cash',      700, 'Amount of cash zombies receive for turning a human to a zombie')
cvar_zombie_replenish_chance = config.cvar('cheapzombie_zombie_replenish_chance', 20,  'Percent chance a human will turn into a zombie when a zombie dies (only if number of humans is greater than number of zombies)')
config.text('\n')

config.text('  *** Zombie health options ***')
cvar_zombie_health             = config.cvar('cheapzombie_zombie_health',             250, 'Starting health of zombies')
cvar_zombie_regen_health       = config.cvar('cheapzombie_zombie_regen_health',       6,   'Amount of health zombies regenerate each iteration')
cvar_zombie_regen_delay        = config.cvar('cheapzombie_zombie_regen_delay',        2,   'Number of seconds between regeneration iterations')
cvar_zombie_regen_initialdelay = config.cvar('cheapzombie_zombie_regen_initialdelay', 7,   'Number of seconds after taking damage a zombie can start regeneration')
cvar_zombie_leech              = config.cvar('cheapzombie_zombie_leech',              50,  'Percent of damage zombies cause that will be regenerated as health')
cvar_zombie_healthmax          = config.cvar('cheapzombie_zombie_healthmax',          400, 'Maximum amount of health for zombies')
config.text('\n')

config.text('  *** Zombie respawn options ***')
cvar_zombie_respawn             = config.cvar('cheapzombie_zombie_respawn',             1,   '0 = no change, 1 = players respawn when becoming a zombie')
cvar_zombie_respawn_attempts    = config.cvar('cheapzombie_zombie_respawn_attempts',    75,  'Maximum number of attempts to respawn players')
config.text('If no spawn point is found players will not respawn.')
cvar_zombie_respawn_distance    = config.cvar('cheapzombie_zombie_respawn_distance',    500, 'Distance a spawn point must be from opponents for a player to spawn on it')
cvar_zombie_respawn_debug       = config.cvar('cheapzombie_zombie_respawn_debug',       0,   'Debug level of error message displayed when no spawn point is found for a player')
config.text('Respawn error messages will only be visible if eventscripts_debug is greater than or equal to cheapdeathmatch_respawn_debug.')
config.text('You can find more information on eventscripts_debug here: http://www.eventscripts.com/pages/Eventscripts_debug')
cvar_zombie_respawn_create_step = config.cvar('cheapzombie_zombie_respawn_create_step', 15,  'Number of seconds between creating spawn points at living player locations--set to 0 to use predefined map spawn points only. NOTE: This value _must_ be 0 if the map changes in layout each round (such as cs_havana).')
config.text('\n')

config.text('  *** Zombie miscellaneous options ***')
cvar_zombie_speed = config.cvar('cheapzombie_zombie_speed', 150, 'Percent of normal players speed zombies receive')
cvar_zombie_team  = config.cvar('cheapzombie_zombie_team',  1,   '0 = zombies are always Terrorists, 1 = zombie team changes with map')
config.text('\n')

config.text('  *** Zombie sound options ***')
cvar_zombie_soundpercent   = config.cvar('cheapzombie_zombie_soundpercent',   35, 'Percent of the map that can hear a zombie groan')
cvar_zombie_turnsound      = config.cvar('cheapzombie_zombie_turnsound',      1,  '0 = no change, 1 = players emit a groan sound when turning into a zombie')
cvar_zombie_groandelay_min = config.cvar('cheapzombie_zombie_groandelay_min', 5,  'Minimum number of seconds between zombie groans')
cvar_zombie_groandelay_max = config.cvar('cheapzombie_zombie_groandelay_min', 30, 'Maximum number of seconds between zombie groans--set to 0 to eliminate random groans')
config.text('\n')

config.text('Use the following server command to add sounds to CheapZombie:')
config.text('')
config.text('cheapzombie_addsound <start/zombie> <"sound relative to ./sound/">')
config.text('')
config.text('Sounds are marked for download automatically.')
config.text('\n')

config.text('Place your cheapzombie_addsound commands below:')
config.command('cheapzombie_addsound')
config.text('\n')

config.text('Uncomment the following default options if you wish to use them:')
config.text('')
config.text('cheapzombie_addsound start "ambient/creatures/town_zombie_call1.wav"')
config.text('cheapzombie_addsound start "npc/crow/alert1.wav"')
config.text('cheapzombie_addsound start "npc/fast_zombie/fz_alert_far1.wav"')
config.text('cheapzombie_addsound start "npc/zombie_poison/pz_call1.wav"')
config.text('')
config.text('cheapzombie_addsound zombie "npc/antlion_guard/angry1.wav"')
config.text('cheapzombie_addsound zombie "npc/antlion_guard/angry2.wav"')
config.text('cheapzombie_addsound zombie "npc/antlion_guard/angry3.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_alert1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_alert2.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_alert3.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_die1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_die2.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_die3.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_pain1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_pain2.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_pain4.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_pain5.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_pain6.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle2.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle3.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle4.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle5.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle6.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle7.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle8.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle9.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle10.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle11.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie/zombie_voice_idle12.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie_poison/pz_alert1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie_poison/pz_alert2.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie_poison/pz_warn1.wav"')
config.text('cheapzombie_addsound zombie "npc/zombie_poison/pz_warn2.wav"')
config.text('\n')

config.text('Sounds can be removed with the following server command:')
config.text('')
config.text('cheapzombie_removesound <start/zombie> <"sound relative to ./sound/">')
config.text('')
config.text('Due to the fact sounds can be added and removed above, this command will not be used by most users.')
config.text('\n')

config.text('***** Map options *****')
cvar_map_lightstyle = config.cvar('cheapzombie_map_lightstyle', 2, 'Map lightstyle from 1 (darkest) to 7 (normal) -- set to 0 for no change')
config.text('\n')

config.text('Use the following server command to skyboxes to CheapZombie:')
config.text('')
config.text('cheapzombie_addskybox <skybox>')
config.text('')
config.text('Custom skyboxes will NOT be marked for download!')
config.text('\n')

config.text('Place your cheapzombie_addskybox commands below:')
config.command('cheapzombie_addskybox')
config.text('\n')

config.text('Uncomment the following default options if you wish to use them:')
config.text('(These options require no client download.)')
config.text('')
config.text('cheapzombie_addskybox de_cobble')
config.text('cheapzombie_addskybox de_piranesi')
config.text('cheapzombie_addskybox hav')
config.text('cheapzombie_addskybox sky_borealis01')
config.text('cheapzombie_addskybox sky_day01_09')
config.text('cheapzombie_addskybox sky_day02_09')
config.text('cheapzombie_addskybox sky_day03_01')
config.text('cheapzombie_addskybox sky_day03_06')
config.text('\n')

config.text('Skybox possibilities can be removed with the following server command:')
config.text('')
config.text('cheapzombie_removeskybox <skybox>')
config.text('')
config.text('Due to the fact skybox possibilites can be added and removed above, this command will not be used by most users.')
config.text('\n')

config.text('***** Announcement options *****')
cvar_announce_initialdelay_chat   = config.cvar('cheapzombie_announce_initialdelay_chat',   2, '0 = no change, 1 = announce on the console at the beginning of the round when zombies will appear, 2 = announce in chat area at the beginning of the round when zombies will appear')
cvar_announce_initialdelay_center = config.cvar('cheapzombie_announce_initialdelay_center', 1, '0 = no change, 1 = announce in center text at the beginning of the round when zombies will appear')
cvar_announce_initialdelay_hud    = config.cvar('cheapzombie_announce_initialdelay_hud',    1, '0 = no change, 1 = announce in a HUD hint at the beginning of the round when zombies will appear')
config.text('')
cvar_announce_zombify_player_chat   = config.cvar('cheapzombie_announce_zombify_player_chat',   2, '0 = no change, 1 = announce to players on the console when they become a zombie, 2 = announce to players in chat area when they become a zombie')
cvar_announce_zombify_player_center = config.cvar('cheapzombie_announce_zombify_player_center', 1, '0 = no change, 1 = announce to players in center text when they become a zombie')
cvar_announce_zombify_player_hud    = config.cvar('cheapzombie_announce_zombify_player_hud',    1, '0 = no change, 1 = announce to players in a HUD hint when they become a zombie')
config.text('')
cvar_announce_zombify_global_chat   = config.cvar('cheapzombie_announce_zombify_global_chat',   2, '0 = no change, 1 = announce to all players on the console when a player becomes a zombie, 2 = announce to all players in chat area when a player becomes a zombie')
cvar_announce_zombify_global_center = config.cvar('cheapzombie_announce_zombify_global_center', 0, '0 = no change, 1 = announce to all players in center text when a player becomes a zombie')
cvar_announce_zombify_global_hud    = config.cvar('cheapzombie_announce_zombify_global_hud',    0, '0 = no change, 1 = announce to all players in a HUD hint when a player becomes a zombie')
config.text('')
cvar_announce_win_chat   = config.cvar('cheapzombie_announce_win_chat',   1, '0 = no change, 1 = announce on the console when a team wins, 2 = announce in chat area when a team wins')
cvar_announce_win_center = config.cvar('cheapzombie_announce_win_center', 1, '0 = no change, 1 = announce in center text when a team wins')
cvar_announce_win_hud    = config.cvar('cheapzombie_announce_win_hud',    1, '0 = no change, 1 = announce in a HUD hint when a team wins')
config.text('\n')

config.text('***** Admin options *****')
cvar_trigger          = config.cvar('cheapzombie_trigger',          '!czadmin', 'Say command to open CheapZombie admin menu--set to "none" to eliminate')
cvar_trigger_announce = config.cvar('cheapzombie_trigger_announce', 2,          '0 = no change, 1 = announce menu trigger to authorized players on the console at the beginning of each round, 2 = announce menu trigger to authorized players in chat area at the beginning of each round')
config.text('\n')

config.text('Use the following server command to add CheapZombie admins:')
config.text('')
config.text('cheapzombie_addadmin <"SteamID">')
config.text('')
config.text('When on a LAN use LAN_<name>.')
config.text('If you use an auth provider the cheapzombie_admin permission will allow players to use the menu.')
config.text('That permission is automatically granted to the ADMIN level.')
config.text('\n')

config.text('Place your cheapzombie_addadmin commands below:')
config.command('cheapzombie_addadmin')
config.text('\n')

config.text('Uncomment the following default options if you wish to use them:')
config.text('')
config.text('cheapzombie_addadmin "LAN_SUPERDAVE"')
config.text('cheapzombie_addadmin "STEAM_0:0:0000"')
config.text('\n')

config.text('The following server command can be used to remove CheapZombie admins:')
config.text('')
config.text('cheapzombie_removeadmin <"SteamID">')
config.text('')
config.text('Due to the fact CheapZombie admins can be added and removed above, this command will not be used by most users')
config.text('\n')

config.text('***** Documentation *****')
config.text('')
config.text('The cvar cheapzombie_teamzombie will be set to the zombie team number for comparison.')
config.text('')
config.text('You can use the cheapzombie_endround server command (no parameters) to safely end the CheapZombie round.')
config.text('This command is similar to the endround cheat command but can be safely used with CheapZombie.')
config.text('')
config.text('This addon removes but does not restore the cheat restriction from the "endround" command.')
config.text('\n')
config.text('The following events will fire when CheapZombie is loaded:')
config.text('')
config.text('cheapzombie_zombify')
config.text('- Fires when a player turns into a zombie')
config.text('   event_var(userid)          - Userid of the player who turned into a zombie')
config.text('   event_var(attacker)        - Attacker who turned the player into a zombie (if applicable)')
config.text('   event_var(damage)          - Damage the player caused as a human')
config.text('')
config.text('cheapzombie_win')
config.text('- Fires when either humans or zombies win')
config.text('   event_var(userid)          - Userid of the player who caused the win (if applicable)')
config.text('   event_var(winner)          - Team that won ("HUMANS", "ZOMBIES")')
config.text('   event_var(team)            - Team number of winning team (check against cheapzombie_teamzombie)')

config.write()

cvar_teamzombie = es.ServerVar('cheapzombie_teamzombie', 2, 'Team number of zombies')


###


class SpawnPointManager(object):
   friend_dist = 100

   def __init__(self, maxcount=1000):
      self.locations = []
      self.surefires = []
      self.obstacles = {}
      self.maxcount  = maxcount

   """ Spawn point creation functions """

   def mapStart(self):
      self.removeDelay()

      self.locations = []
      self.obstacles.clear()

      for index in es.createentitylist('info_player_terrorist').keys() + es.createentitylist('info_player_counterterrorist').keys():
         self._addLocation(map(float, es.getindexprop(index, 'CBaseEntity.m_vecOrigin').split(',')))

      self.surefires = list(self.locations)

   def roundStart(self):
      self.removeDelay()

      delay = float(cvar_zombie_respawn_create_step)
      if delay and len(self.locations) < self.maxcount:
         gamethread.delayedname(delay, 'cheapzombie_respawn_create', self._createSpawnPoints)

   def removeDelay(self):
      gamethread.cancelDelayed('cheapzombie_respawn_create')

   def _addLocation(self, location):
      if location in self.locations or len(self.locations) >= self.maxcount: return

      self.locations.append(location)

   def _createSpawnPoints(self):
      for userid in filter(lambda x: not cz.getPlayer(x).isDead(), es.getUseridList()):
         if es.getplayerprop(userid, 'CBasePlayer.m_fFlags') & 1 and not es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') & 1:
            self._addLocation(es.getplayerlocation(userid))

      delay = float(cvar_zombie_respawn_create_step)
      if delay and len(self.locations) < self.maxcount:
         gamethread.delayedname(delay, 'cheapzombie_respawn_create', self._createSpawnPoints)

   """ Spawn point retrieval functions """

   def getLocation(self, userid, surefire=False):
      spawns = list(self.surefires if surefire else self.locations)
      if not spawns: return None

      team       = es.getplayerteam(userid)
      enemy_dist = int(cvar_zombie_respawn_distance)
      players    = self.obstacles.copy()

      for loop_userid in filter(lambda x: not cz.getPlayer(x).isDead(), es.getUseridList()):
         players[es.getplayerlocation(loop_userid)] = self.friend_dist if es.getplayerteam(loop_userid) == team and loop_userid <> userid else enemy_dist

      for count in xrange(cvar_zombie_respawn_attempts):
         location = random.choice(spawns)
         if self._checkLocation(location, players):
            x, y, z = location
            return x, y, z + 4

         spawns.remove(location)
         if not spawns: break

      return None

   def _checkLocation(self, location, players):
      for player_location in players:
         if sum((location[x] - player_location[x]) ** 2 for x in range(3)) ** 0.5 <= players[player_location]: return False

      return True

   def addObstacle(self, location):
      self.obstacles[location] = self.friend_dist

   def addSurefire(self, location):
      if location in self.surefires: return

      self.surefires.append(location)

spawnpoints = SpawnPointManager()


###


class CZAuth(object):
   service_auth = lambda self, x: False

   def __init__(self):
      self.admins = set()

      if not services.isRegistered('auth'): return

      auth = services.use('auth')
      auth.registerCapability('cheapzombie_admin', auth.ADMIN)

      self.service_auth = lambda self, x: auth.isUseridAuthorized(x, 'cheapzombie_admin')

   def addPlayer(self, steamid):
      self.admins.add(steamid)

   def removePlayer(self, steamid):
      if steamid in self.admins:
         self.admins.remove(steamid)

   def isAuthed(self, userid):
      if self.service_auth(userid): return True
      return self.getPlayerSteamID(userid) in self.admins

   @staticmethod
   def getPlayerSteamID(userid):
      steamid = es.getplayersteamid(userid)
      return ('LAN_' + es.getplayername(userid).upper()) if steamid == 'STEAM_ID_LAN' else steamid

czauth = CZAuth()


def addadmin_cmd():
   """
   cheapzombie_addadmin <"SteamID">
   """
   if es.getargc() == 2:
      czauth.addPlayer(es.getargv(1).upper())

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_addadmin <\"SteamID\">')

if not es.exists('command', 'cheapzombie_addadmin'):
   es.regcmd('cheapzombie_addadmin', 'cheapzombie/addadmin_cmd', 'cheapzombie_addadmin <\"SteamID\">\nServer command to add CheapZombie admins')


def removeadmin_cmd():
   """
   cheapzombie_removeadmin <"SteamID">
   """
   if es.getargc() == 2:
      czauth.removePlayer(es.getargv(1).upper())

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_removeadmin <\"SteamID\">')

if not es.exists('command', 'cheapzombie_removeadmin'):
   es.regcmd('cheapzombie_removeadmin', 'cheapzombie/removeadmin_cmd', 'cheapzombie_removeadmin <\"SteamID\">\nServer command to remove CheapZombie admins')


###


class ZombieSoundsManager(object):
   soundpath = es.ServerVar('eventscripts_gamedir') + '/sound/'

   def __init__(self):
      self.sounds     = {'start':set(), 'zombie':set()}
      self.lastsounds = {'start':'', 'zombie':''}

   def addSound(self, soundtype, sound):
      self.sounds[soundtype].add(sound)

   def removeSound(self, soundtype, sound):
      current_type = self.sounds[soundtype]
      if sound not in current_type: return

      current_type.remove(sound)

   def markSoundsForDownload(self):
      for sound in filter(lambda x: os.path.isfile(self.soundpath + x), self.sounds):
         es.stringtable('downloadables', 'sound/' + sound)

   def getSound(self, soundtype):
      current_type = self.sounds[soundtype]
      if not self.sounds[soundtype]: return None

      choices = filter(lambda x: x <> self.lastsounds[soundtype], current_type)
      sound = self.lastsounds[soundtype] = random.choice(choices if choices else current_type)

      return sound

zombiesounds = ZombieSoundsManager()


def addsound_cmd():
   """
   cheapzombie_addsound <start/zombie> <"sound relative to ./sound/">
   """
   if es.getargc() == 3:
      soundtype = es.getargv(1).lower()
      if soundtype in ('start', 'zombie'):
         zombiesounds.addSound(soundtype, es.getargv(2))
         return

   es.dbgmsg(0, 'Syntax: cheapzombie_addsound <start/zombie> <\"sound relative to ./sound/\">')

if not es.exists('command', 'cheapzombie_addsound'):
   es.regcmd('cheapzombie_addsound', 'cheapzombie/addsound_cmd', 'cheapzombie_addsound <start/zombie> <\"sound relative to ./sound/\">\nServer command to add zombie sounds')


def removesound_cmd():
   """
   cheapzombie_removesound <start/zombie> <"sound relative to ./sound/">
   """
   if es.getargc() == 3:
      soundtype = es.getargv(1).lower()
      if soundtype in ('start', 'zombie'):
         zombiesounds.removeSound(soundtype, es.getargv(2))
         return

   es.dbgmsg(0, 'Syntax: cheapzombie_removesound <start/zombie> <\"sound relative to ./sound/\">')

if not es.exists('command', 'cheapzombie_removesound'):
   es.regcmd('cheapzombie_removesound', 'cheapzombie/removesound_cmd', 'cheapzombie_removesound <start/zombie> <\"sound relative to ./sound/\">\nServer command to add zombie sounds')


###


class SkyBoxManager(object):
   skybox_cvar = es.ServerVar('sv_skyname')
   lastskybox  = ''

   def __init__(self):
      self.skyboxes = set()

   def addSkyBox(self, name):
      self.skyboxes.add(name)

   def removeSkyBox(self, name):
      if name in self.skyboxes:
         self.skyboxes.remove(name)

   def setSkyBox(self):
      if not self.skyboxes: return

      choices = filter(lambda x: x <> self.lastskybox, self.skyboxes)
      self.skybox_cvar.set(random.choice(choices if choices else list(self.skyboxes)))

skybox = SkyBoxManager()


def addskybox_cmd():
   """
   cheapzombie_addskybox <skybox>
   """
   if es.getargc() == 2:
      skybox.addSkyBox(es.getargv(1))

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_addskybox <skybox>')

if not es.exists('command', 'cheapzombie_addskybox'):
   es.regcmd('cheapzombie_addskybox', 'cheapzombie/addskybox_cmd', 'cheapzombie_addskybox <skybox>\nServer command to add skyboxes to CheapZombie')


def removeskybox_cmd():
   """
   cheapzombie_removeskybox <skybox>
   """
   if es.getargc() == 2:
      skybox.removeSkyBox(es.getargv(1))

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_removeskybox <skybox>')

if not es.exists('command', 'cheapzombie_removeskybox'):
   es.regcmd('cheapzombie_removeskybox', 'cheapzombie/removeskybox_cmd', 'cheapzombie_removeskybox <skybox>\nServer command to remove skyboxes from CheapZombie')


###


class CheapZombiePlayer(object):
   skins = {2:('models/player/t_arctic.mdl', 'models/player/t_guerilla.mdl', 'models/player/t_leet.mdl', 'models/player/t_phoenix.mdl'), 3:('models/player/ct_gign.mdl', 'models/player/ct_gsg9.mdl', 'models/player/ct_sas.mdl', 'models/player/ct_urban.mdl')}

   def __init__(self, userid):
      self.userid = userid
      self.handle = es.getplayerhandle(userid)
      self.isbot  = es.getplayersteamid(userid) == 'BOT'

      self._spawn()

   """ Class-specific functions """

   def _spawn(self):
      pass

   def reset(self, connected):
      pass

   def addDamage(self, damage):
      pass

   def leechDamage(self, damage):
      pass

   def getDamage(self, realdamage=False):
      return None

   def playerHurt(self, attacker, dmg_health):
      pass

   def itemPickup(self, item):
      pass

   """ General class functions """

   def removeWeapon(self, weapon):
      for index in es.createentitylist('weapon_' + weapon):
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == self.handle:
            if es.createplayerlist(self.userid)[self.userid]['weapon'] == 'weapon_' + weapon:
               es.cexec(self.userid, 'lastinv')

            es.server.cmd('es_xremove %s' % index)

   def setTeam(self, team):
      nvg = es.getplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision')
      es.setplayerprop(self.userid, 'CBaseEntity.m_iTeamNum', team)
      if team not in self.skins: return

      es.setplayerprop(self.userid, 'CBaseEntity.m_nModelIndex', es.precachemodel(random.choice(self.skins[team])))

      es.server.queuecmd('es_xfire %s !self addouput \"rendermode 1\"' % self.userid)
      es.server.queuecmd('es_xfire %s !self alpha 255' % self.userid)
      es.server.queuecmd('es_xfire %s !self color \"255 255 255\"' % self.userid)

      es.setplayerprop(self.userid, 'CCSPlayer.m_bHasDefuser', 0)
      es.setplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision', nvg)

   def setSpeed(self, speed):
      es.setplayerprop(self.userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', speed)

   def setHealth(self, health):
      es.setplayerprop(self.userid, 'CBasePlayer.m_iHealth', health)

   def getHealth(self):
      return es.getplayerprop(self.userid, 'CBasePlayer.m_iHealth')

   def getLang(self):
      return playerlib.getPlayer(self.userid).get('lang')

   def getName(self):
      return es.getplayername(self.userid)

   def isDead(self):
      return es.getplayerprop(self.userid, 'CBasePlayer.pl.deadflag')

   def isBot(self):
      return self.isbot

   def addScore(self, amount):
      entity_list = es.createentitylist('game_score')
      if len(entity_list) > 1:
         for index in entity_list.keys()[1:]:
            es.server.cmd('es_xremove %s' % index)
      elif not entity_list:
         es.server.cmd('es_xentcreate %s game_score' % self.userid)

      es.server.queuecmd('es_xfire %s game_score addoutput \"spawnflags 1\"' % self.userid)
      es.server.queuecmd('es_xfire %s game_score addoutput \"points %s\"' % (self.userid, amount))
      es.server.queuecmd('es_xfire %s game_score applyscore' % self.userid)

   def addCash(self, amount):
      es.setplayerprop(self.userid, 'CCSPlayer.m_iAccount', min(16000, es.getplayerprop(self.userid, 'CCSPlayer.m_iAccount') + amount))

   def hudHint(self, text):
      """Sends the player a HUD hint"""
      es.usermsg('create', 'cheapzombie_hud', 'HintText')
      es.usermsg('write', 'short', 'cheapzombie_hud', -1)
      es.usermsg('write', 'string', 'cheapzombie_hud', text)
      es.usermsg('send', 'cheapzombie_hud', self.userid)
      es.usermsg('delete', 'cheapzombie_hud')


#


class Zombie(CheapZombiePlayer):
   """ Setup functions """

   def _spawn(self):
      #self.setTeam(cz.zombieteam)
      self.setSpeed(cvar_zombie_speed / 100.)
      self.setHealth(cvar_zombie_health)
      es.setplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision', 1)

      entlist = es.createentitylist()
      for index in filter(lambda x: entlist[x]['classname'].startswith('weapon_'), entlist):
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == self.handle:
            es.server.cmd('es_xremove %s' % index)

      es.server.cmd('es_xgive %s weapon_knife' % self.userid)
      es.sexec(self.userid, 'use weapon_knife')

      sound = zombiesounds.getSound('zombie')
      if sound:
         if int(cvar_zombie_turnsound):
            gamethread.delayed(0.1, es.emitsound, ('player', self.userid, sound, 1., (100. - float(cvar_zombie_soundpercent)) / 100.))

         delaymax = int(cvar_zombie_groandelay_max)
         if delaymax:
            gamethread.delayedname(random.randint(cvar_zombie_groandelay_min, delaymax), 'cheapzombie_sound_%s' % self.userid, self._groan)

      if int(cvar_zombie_respawn):
         self._newLocation()

   def reset(self, connected):
      gamethread.cancelDelayed('cheapzombie_regen_%s' % self.userid)
      gamethread.cancelDelayed('cheapzombie_respawn_%s' % self.userid)
      gamethread.cancelDelayed('cheapzombie_sound_%s' % self.userid)

      if connected:
         es.setplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision', 0)
         self.setSpeed(1.)

   def addDamage(self, damage):
      health = self.getHealth() - damage
      if health > 0:
         self.setHealth(health)

      else:
         es.sexec(self.userid, 'kill')

   def leechDamage(self, damage):
      self.setHealth(min((damage * float(cvar_zombie_leech) / 100.) + self.getHealth(), cvar_zombie_healthmax))

   """ Event functions """

   def playerHurt(self, attacker, dmg_health):
      if attacker:
         cz.getPlayer(attacker).addDamage(dmg_health)

      regenhealth = int(cvar_zombie_regen_health)
      if regenhealth:
         gamethread.cancelDelayed('cheapzombie_regen_%s' % self.userid)
         gamethread.delayedname(cvar_zombie_regen_initialdelay, 'cheapzombie_regen_%s' % self.userid, self._regen)

   def itemPickup(self, item):
      if item <> 'knife':
         self.removeWeapon(item)

   """ Internal functions """

   def _newLocation(self, location=None, count=0):
      if not location is None:
         current_location = es.getplayerlocation(self.userid)
         if sum((location[x] - current_location[x]) ** 2 for x in range(3)) ** 0.5 > 2:
            if min([sum((pl_location[x] - current_location[x]) ** 2 for x in range(3)) for pl_location in map(es.getplayerlocation, filter(lambda userid: not cz.getPlayer(userid).isDead() and userid <> self.userid, es.getUseridList()))]) > 100:
               spawnpoints.addSurefire(location)
               return

         es.dbgmsg(1, 'CheapZombie: Found player %s (userid %s) stuck at %s' % (self.getName(), self.userid, current_location))
         spawnpoints.addObstacle(current_location)

         if count > 20:
            es.dbgmsg(cvar_zombie_respawn_debug, 'CheapZombie: Unable to free player %s (userid %s) stuck at %s' % (self.getName(), self.userid, current_location))
            return

      location = spawnpoints.getLocation(self.userid, count > 15)
      if location is None:
         es.dbgmsg(cvar_zombie_respawn_debug, 'CheapZombie: Unable to find spawn point for %s (userid %s)' % (self.getName(), self.userid))
         return

      es.server.queuecmd('es_xsetpos %s %s %s %s' % ((self.userid,) + location))
      gamethread.cancelDelayed('cheapzombie_respawn_%s' % self.userid)
      gamethread.delayedname(0.3, 'cheapzombie_respawn_%s' % self.userid, self._newLocation, (location, count + 1))

   def _regen(self):
      regenhealth = int(cvar_zombie_regen_health)
      if not regenhealth: return

      maxhealth = int(cvar_zombie_healthmax)
      health    = self.getHealth()
      newhealth = min(health + regenhealth, maxhealth)
      self.setHealth(newhealth)

      if newhealth < maxhealth:
         gamethread.delayedname(cvar_zombie_regen_delay, 'cheapzombie_regen_%s' % self.userid, self._regen)

   def _groan(self):
      sound = zombiesounds.getSound('zombie')
      if sound:
         gamethread.delayed(0.1, es.emitsound, ('player', self.userid, sound, 1., (100. - float(cvar_zombie_soundpercent)) / 100.))

         delaymax = int(cvar_zombie_groandelay_max)
         if delaymax:
            gamethread.delayedname(random.randint(cvar_zombie_groandelay_min, delaymax), 'cheapzombie_sound_%s' % self.userid, self._groan)


#


class Human(CheapZombiePlayer):
   handguns = set(('deagle', 'usp', 'fiveseven', 'p228', 'glock'))

   damage = 0

   """ Setup functions """

   def _spawn(self):
      self.damage = 0

      nvg = es.getplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision')

      self.setTeam(cz.humanteam)
      self.setHealth(1024 + cvar_human_health)

      if es.createplayerlist(self.userid)[self.userid]['weapon'] == 'weapon_knife':
         es.cexec(self.userid, 'lastinv')
      for index in es.createentitylist('weapon_knife'):
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == self.handle:
            es.server.cmd('es_xremove %s' % index)
            break

      if int(cvar_human_bot_removehe) and self.isbot:
         self.removeWeapon('hegrenade')

      es.setplayerprop(self.userid, 'CCSPlayer.m_bHasNightVision', nvg)

      handgun_choices = self.handguns.union(map(lambda x: x.lower().replace('weapon_', ''), str(cvar_human_handgun).split(';')))
      if not handgun_choices: return

      self._removeHandgun()
      es.server.queuecmd('es_xgive %s weapon_%s' % (self.userid, random.choice(list(handgun_choices))))

   def reset(self, connected):
      if not connected: return

      self.setHealth(max(1, self.getHealth() - 1024))

   def addDamage(self, damage):
      self.damage += damage

   def getDamage(self, realdamage=False):
      return (self.damage - cvar_zombie_bothandicap) if self.isbot and not realdamage else self.damage

   """ Event functions """

   def playerHurt(self, attacker, dmg_health):
      health = self.getHealth()

      if attacker:
         ak_player = cz.getPlayer(attacker)

         if es.getplayerteam(attacker) == es.getplayerteam(self.userid):
            if attacker <> self.userid:
               self.setHealth(self.getHealth() + dmg_health)
               ak_player.setHealth(ak_player.getHealth() - dmg_health)
               ak_player.playerHurt(attacker, dmg_health)

               return

         elif health <= 1024:
            ak_player.addScore(cvar_zombie_create_score)
            ak_player.addCash(cvar_zombie_create_cash)

         ak_player.leechDamage(dmg_health)

      if health <= 1024:
         cz.spawnZombie(self.userid, attacker)

   def itemPickup(self, item):
      if item == 'knife':
         self.removeWeapon('knife')

      elif item == 'hegrenade':
         if int(cvar_human_bot_removehe) and self.isbot:
            self.removeWeapon('hegrenade')

      elif item == 'c4':
         self.removeWeapon('c4')

      else:
         cz._removeIdleWeapons()

   """ Internal functions """

   def _removeHandgun(self):
      for weapon in self.handguns:
         for index in es.createentitylist('weapon_' + weapon):
            if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == self.handle:
               if es.createplayerlist(self.userid)[self.userid]['weapon'] == 'weapon_' + weapon:
                  es.cexec(self.userid, 'lastinv')

               es.server.cmd('es_xremove %s' % index)
               return


###


class CheapZombieManager(object):
   in_round   = False
   zombieteam = 2
   humanteam  = 3

   quota_cvar      = es.ServerVar('bot_quota')
   bot_quota       = None
   quota_mode_cvar = es.ServerVar('bot_quota_mode')
   bot_quota_mode  = None
   mp_roundtime    = es.ServerVar('mp_roundtime')

   def __init__(self):
      self.players    = {}
      self.teams      = {}
      self.popups     = {}
      self.buyzones   = set()
      self.fireddeath = set()

   """ Player functions """

   def getPlayer(self, userid):
      userid = int(userid)
      if not userid: raise ValueError, 'Ivalid userid (%s)' % userid

      if userid not in self.players:
         self.players[userid] = CheapZombiePlayer(userid)

      return self.players[userid]

   def removePlayer(self, userid, connected=False):
      userid = int(userid)
      if not userid: raise ValueError, 'Ivalid userid (%s)' % userid

      if userid in self.teams:
         if connected:
            self.getPlayer(userid).setTeam(self.teams[userid])
         del self.teams[userid]

      if userid in self.players:
         self.players[userid].reset(connected)
         del self.players[userid]

      self._checkWin()
   
   def removePopup(self, userid):
      userid = int(userid)
      if userid in self.popups:
         del self.popups[userid]

   def clearPlayers(self, connected=False):
      if connected:
         for userid in self.teams:
            self.getPlayer(userid).setTeam(self.teams[userid])

      for userid in self.players:
         self.players[userid].reset(connected)

      self.players.clear()
      self.teams.clear()

   def spawnHuman(self, userid):
      self.getPlayer(userid).reset(False)
      self.players[userid] = Human(userid)

   def spawnZombie(self, userid, attacker=0):
      gamethread.cancelDelayed('cheapzombie_zombify')
      if not self.in_round: return

      zombie_player = self.getPlayer(userid)

      chat    = int(cvar_announce_zombify_player_chat)
      center  = int(cvar_announce_zombify_player_center)
      hud     = int(cvar_announce_zombify_player_hud)
      tokens  = {'name':zombie_player.getName(), 'damage':zombie_player.getDamage(True)}
      message = lang_text('zombify player', tokens, zombie_player.getLang())

      if chat:
         if chat == 1:
            es.cexec(userid, 'echo ' + remove_tags(message))
         else:
            es.tell(userid, '#multi', message)

      if center:
         es.centertell(userid, remove_tags(message))

      if hud:
         zombie_player.hudHint(remove_tags(message))

      chat   = int(cvar_announce_zombify_global_chat)
      center = int(cvar_announce_zombify_global_center)
      hud    = int(cvar_announce_zombify_global_hud)

      for loop_userid in es.getUseridList():
         if loop_userid == userid: continue

         player  = self.getPlayer(loop_userid)
         message = lang_text('zombify global', tokens, player.getLang())

         if chat:
            if chat == 1:
               es.cexec(loop_userid, 'echo ' + remove_tags(message))
            else:
               es.tell(loop_userid, '#multi', message)

         if center:
            es.centertell(loop_userid, remove_tags(message))

         if hud:
            player.hudHint(remove_tags(message))

      self.fireddeath.add(userid)
      es.event('initialize', 'player_death')
      es.event('setint',     'player_death', 'userid',   userid)
      es.event('setint',     'player_death', 'attacker', attacker if attacker else userid)
      es.event('setstring',  'player_death', 'weapon',   'knife')
      es.event('setint',     'player_death', 'headshot', 0)
      es.event('fire',       'player_death')

      es.event('initialize', 'cheapzombie_zombify')
      es.event('setint',     'cheapzombie_zombify', 'userid', userid)
      es.event('setint',     'cheapzombie_zombify', 'attacker', attacker)
      es.event('setint',     'cheapzombie_zombify', 'damage', zombie_player.getDamage(True))
      es.event('fire',       'cheapzombie_zombify')

      es.event('initialize', 'player_spawn')
      es.event('setint',     'player_spawn', 'userid', userid)
      es.event('fire',       'player_spawn')

      zombie_player.reset(False)
      self.players[userid] = Zombie(userid)

      if attacker:
         self._checkWin(attacker)

   """ Event functions """

   def mapStart(self):
      self._loadEvents()
      self.clearPlayers()

      self.popups.clear()
      self.fireddeath.clear()
      self.buyzones.clear()

      spawnpoints.mapStart()
      skybox.setSkyBox()

      self.zombieteam = 2
      self.humanteam  = 3
      cvar_teamzombie.set(2)

      self._cancelRoundEnd()
      self.roundEnd()

      lightstyle = int(cvar_map_lightstyle)
      if lightstyle:
         gamethread.delayed(0.1, es.lightstyle, (0, chr(96 + lightstyle)))

   def roundStart(self):
      if es.getentityindex('func_bomb_target') <> -1 and int(cvar_zombie_team):
         self.zombieteam = 3
         self.humanteam  = 2
         cvar_teamzombie.set(3)

      if self.in_round: self.roundEnd()
      if es.getlivingplayercount() <= 1: return

      self.bot_quota_mode = str(self.quota_mode_cvar)
      self.quota_mode_cvar.set('normal')
      self.bot_quota = int(self.quota_cvar)
      self.quota_cvar.set(len(filter(lambda x: self.getPlayer(x).isbot, es.getUseridList())))

      self.in_round = True

      userid = es.getuserid()
      if not userid: return
      es.server.queuecmd('es_xfire %s weapon_c4 kill' % userid)
      es.server.queuecmd('es_xfire %s func_bomb_target kill' % userid)
      es.server.queuecmd('es_xfire %s hostage_entity kill' % userid)
      es.server.queuecmd('es_xfire %s func_hostage_rescue kill' % userid)

      sound = zombiesounds.getSound('start')
      if sound:
         es.emitsound('player', userid, sound, 1., 0.)

      delay_min = int(cvar_zombie_initialdelay_min)
      delay_max = int(cvar_zombie_initialdelay_max)

      chat   = int(cvar_announce_initialdelay_chat)
      center = int(cvar_announce_initialdelay_center)
      hud    = int(cvar_announce_initialdelay_hud)
      admin  = int(cvar_trigger_announce)
      tokens = {'min':delay_min, 'max':delay_max}

      for userid in es.getUseridList():
         player  = self.getPlayer(userid)
         pl_lang = player.getLang()
         message = lang_text('zombies appear', tokens, pl_lang)

         if chat:
            if chat == 1:
               es.cexec(userid, 'echo ' + remove_tags(message))
            else:
               es.tell(userid, '#multi', message)

         if center:
            es.centertell(userid, remove_tags(message))

         if hud:
            player.hudHint(remove_tags(message))

         if czauth.isAuthed(userid):
            if admin == 1:
               es.cexec(userid, 'echo ' + remove_tags(lang_text('admin trigger', {'trigger':say_command}, pl_lang)))
            elif admin:
               es.tell(userid, '#multi', lang_text('admin trigger', {'trigger':say_command}, pl_lang))

         if not player.isDead():
            self.spawnHuman(userid)

      es.addons.registerClientCommandFilter(self._dropFilter)
      self._removeIdleWeapons()

      self.buyzones.clear()
      for index in es.createentitylist('func_buyzone'):
         if es.getindexprop(index, 'CBaseEntity.m_iTeamNum') == self.zombieteam:
            es.setindexprop(index, 'CBaseEntity.m_iTeamNum', self.humanteam)
            self.buyzones.add(index)

      gamethread.cancelDelayed('cheapzombie_zombify')
      self._cancelRoundEnd()

      gamethread.delayedname(self.mp_roundtime * 60., 'cheapzombie_roundend', self._forceRoundEnd)
      gamethread.delayedname(random.randint(delay_min, delay_max), 'cheapzombie_zombify', self._createZombies)

   def roundEnd(self):
      if not self.in_round: return

      self.quota_mode_cvar.set(self.bot_quota_mode)
      self.quota_cvar.set(self.bot_quota)

      self.clearPlayers(True)
      self._resetBuyzones()

      self.in_round = False
      gamethread.cancelDelayed('cheapzombie_zombify')
      gamethread.cancelDelayed('cheapzombie_drop')
      es.addons.unregisterClientCommandFilter(self._dropFilter)

   def playerSpawn(self, userid):
      if userid in self.teams: return

      self.getPlayer(userid).addCash(cvar_human_spawn_cash)
      self.teams[userid] = es.getplayerteam(userid)

      if self.in_round:
         self.spawnHuman(userid)

   def playerDeath(self, userid):
      if not self.in_round: return

      if userid in self.fireddeath:
         self.fireddeath.remove(userid)
         self.getPlayer(userid).setTeam(self.zombieteam)
         return

      if isinstance(self.getPlayer(userid), Zombie) and random.randint(1, 100) <= cvar_zombie_replenish_chance:
         zcount = es.getlivingplayercount(self.zombieteam)
         if zcount < es.getlivingplayercount(self.humanteam) and zcount:
            self._createZombies(1)

      self.removePlayer(userid, True)

      self._removeIdleWeapons()

   """ Internal functions """

   def _cancelRoundEnd(self):
      gamethread.cancelDelayed('cheapzombie_roundend')

   def _forceRoundEnd(self):
      self.__announceWin('time expired')

      self._cancelRoundEnd()
      self.roundEnd()

      es.flags('remove', 'cheat', 'endround')
      gamethread.delayedname(3, 'cheapzombie_roundend', es.server.queuecmd, 'endround')

   def _checkWin(self, attacker=0):
      if not self.in_round: return

      if not self._livingPlayerCount(Zombie):
         if self._livingPlayerCount(Human) == 1:
            laststanding = filter(lambda x: not self.getPlayer(x).isDead(), es.getUseridList())[0]
            lastplayer   = self.getPlayer(laststanding)

            lastplayer.addScore(cvar_human_laststanding_score)
            lastplayer.addCash(cvar_human_laststanding_cash)

            self.__announceWin('humans win')

            es.event('initialize', 'cheapzombie_win')
            es.event('setint',     'cheapzombie_win', 'userid', laststanding)
            es.event('setstring',  'cheapzombie_win', 'winner', 'HUMANS')
            es.event('setint',     'cheapzombie_win', 'team',   self.humanteam)
            es.event('fire',       'cheapzombie_win')

            self.roundEnd()

         else:
            gamethread.cancelDelayed('cheapzombie_zombify')
            gamethread.delayedname(random.randint(cvar_zombie_delay_min, cvar_zombie_delay_max), 'cheapzombie_zombify', self._createZombies)

      elif not self._livingPlayerCount(Human):
         handgun_choices = Human.handguns.union(map(lambda x: x.lower().replace('weapon_', ''), str(cvar_human_handgun).split(';')))
         if handgun_choices and attacker:
            weapon = random.choice(list(handgun_choices))
            es.server.queuecmd('es_xgive %(userid)s weapon_%(weapon)s;es_xsexec %(userid)s use weapon_%(weapon)s' % {'userid':attacker, 'weapon':weapon})

         self.__announceWin('zombies win')

         es.event('initialize', 'cheapzombie_win')
         es.event('setint',     'cheapzombie_win', 'userid', attacker)
         es.event('setstring',  'cheapzombie_win', 'winner', 'ZOMBIES')
         es.event('setint',     'cheapzombie_win', 'team',   self.zombieteam)
         es.event('fire',       'cheapzombie_win')

         self.roundEnd()

      else:
         # Original team count
         original_t     = self._getOriginalTeamList(2)
         original_ct    = self._getOriginalTeamList(3)
         living_players = filter(lambda x: not self.getPlayer(x).isDead(), es.getUseridList())
         random.shuffle(living_players)

         humans = sorted(filter(lambda x: isinstance(self.getPlayer(x), Human), living_players), key=lambda x: self.getPlayer(x).getDamage())
         if not filter(lambda x: x in original_t, humans) or not filter(lambda x: x in original_ct, humans):
            for userid in humans[:~0]:
               self.spawnZombie(userid)

         living_t  = filter(lambda x: x in original_t, living_players)
         living_ct = filter(lambda x: x in original_ct, living_players)

         lastplayer = humans[~0]
         self.__checkKill(living_t, living_ct, lastplayer)
         self.__checkKill(living_ct, living_t, lastplayer)

   def _livingPlayerCount(self, instance):
      return len(filter(lambda x: isinstance(x, instance) and not x.isDead(), map(self.getPlayer, es.getUseridList())))

   def __checkKill(self, team1, team2, lastplayer):
      if len(team1) == 1:
         if isinstance(self.getPlayer(team1[0]), Zombie):
            for userid in team2:
               if lastplayer <> userid:
                  es.sexec(userid, 'kill')

   def __announceWin(self, winner):
      chat   = int(cvar_announce_win_chat)
      center = int(cvar_announce_win_center)
      hud    = int(cvar_announce_win_hud)

      for userid in es.getUseridList():
         player  = self.getPlayer(userid)
         message = lang_text(winner, {}, player.getLang())

         if chat:
            if chat == 1:
               es.cexec(userid, 'echo ' + remove_tags(message))
            else:
               es.tell(userid, '#multi', message)

         if center:
            es.centertell(userid, remove_tags(message))

         if hud:
            player.hudHint(remove_tags(message))

   def _createZombies(self, number=0):
      bot_handicap = int(cvar_zombie_bothandicap)
      original_t   = self._getOriginalTeamList(2)
      original_ct  = self._getOriginalTeamList(3)
      useridlist   = es.getUseridList()
      random.shuffle(useridlist)

      players = sorted(filter(lambda x: isinstance(self.getPlayer(x), Human) and not self.getPlayer(x).isDead(), useridlist), key=lambda x: self.getPlayer(x).getDamage())

      new_zombies = max(1, random.randint(cvar_zombie_percent_min, cvar_zombie_percent_max) * es.getlivingplayercount(self.humanteam) / 100)
      for count in xrange(number) if number else xrange(new_zombies if new_zombies > 1 else (cvar_zombie_percent_max * es.getlivingplayercount(self.humanteam) / 100)):
         if len(players) <= 1: break

         t_players  = filter(lambda x: x in original_t, players)
         ct_players = filter(lambda x: x in original_ct, players)

         if len(t_players) > len(ct_players):
            temp_players = t_players

         elif len(t_players) < len(ct_players):
            temp_players = ct_players

         else:
            temp_players = players

         userid = temp_players[0]
         if bot_handicap == -1:
            bots = filter(lambda x: self.getPlayer(x).isBot(), players)
            if bots: userid = bots[0]

         self.spawnZombie(userid)
         players.remove(userid)

      self._checkWin()

   def _getOriginalTeamList(self, team):
      return filter(lambda x: self.teams[x] == team, self.teams)

   def _resetBuyzones(self):
      for index in self.buyzones:
         es.setindexprop(index, 'CBaseEntity.m_iTeamNum', self.zombieteam)

   def _removeIdleWeapons(self):
      entlist = es.createentitylist()
      for index in filter(lambda x: entlist[x]['classname'].startswith('weapon_'), entlist):
         if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == -1:
            es.server.cmd('es_xremove %s' % index)

   def _dropFilter(self, userid, args):
      if args[0].lower() == 'drop':
         gamethread.delayedname(0.1, 'cheapzombie_drop', self._removeIdleWeapons)
      return True

   def _loadEvents(self):
      """Loads the .res file for the events"""
      if os.path.isfile(es.getAddonPath('cheapzombie') + '/cheapzombie.res'):
         es.loadevents('declare', 'addons/eventscripts/cheapzombie/cheapzombie.res')
      else:
         events = {'cheapzombie_zombify':{'userid':'short', 'attacker':'short', 'damage':'short'}, 'cheapzombie_win':{'userid':'short', 'winner':'string', 'team':'short'}}

         if not os.path.isfile(es.getAddonPath('cheapzombie') + 'es_cheapzombie_events_db.txt'):
            es.keygroupcreate('cheapzombie_events')
            for event_name in events:
               es.keycreate('cheapzombie_events', event_name)
               for event_var in events[event_name]:
                  es.keysetvalue('cheapzombie_events', event_name, event_var, events[event_name][event_var])
            es.keygroupsave('cheapzombie_events', '|cheapzombie')
            es.keygroupdelete('cheapzombie_events')
         es.loadevents('declare', 'addons/eventscripts/cheapzombie/es_cheapzombie_events_db.txt')
         es.dbgmsg(0, 'CheapZombie: Unable to load cheapzombie.res! Please ensure it is in the ./cheapzombie/ directory.')

   """ Menu functions """

   def sendMenu(self, userid):
      player_lang = self.getPlayer(userid).getLang()
      popup.send(userid, 0, '%s\n \n->1. %s\n \n->3. %s\n \n->5. %s\n \n0. %s' % (lang_text('menu title', lang=player_lang),
         lang_text('menu zombify', lang=player_lang), lang_text('menu respawn', lang=player_lang), lang_text('menu endround', lang=player_lang),
         lang_text('cancel', lang=player_lang)), self.mainMenuSelect)

   def mainMenuSelect(self, userid, item):
      if item == 1:
         self.sendPlayerMenu(userid, 'zombify')

      elif item == 3:
         self.sendPlayerMenu(userid, 'respawn')

      elif item == 5:
         self._cancelRoundEnd()
         self._forceRoundEnd()

      else:
         return True

      return False

   def sendPlayerMenu(self, userid, menutype=''):
      if menutype:
         player = self.popups[userid] = {'type':menutype, 'index':0}

         targetteam = Zombie if menutype == 'respawn' else Human
         player['playerlist'] = sorted([(es.getplayername(x), x) for x in filter(lambda x: not self.getPlayer(x).isDead() and
            isinstance(self.getPlayer(x), targetteam), es.getUseridList())], key=lambda x: (x[0].lower(), x[1]))

      else:
         if userid not in self.popups: return

         player = self.popups[userid]

      player_lang = self.getPlayer(userid).getLang()
      if not self.in_round:
         next = ' '

      elif player['type'] == 'respawn':
         next = ('9. ' + lang_text('next', lang=player_lang)) if player['index'] + 7 < len(player['playerlist']) else ' '

      elif len(player['playerlist']) > 1:
         next = '9. ' + lang_text('next' if player['index'] + 7 < len(player['playerlist']) else 'automatic', lang=player_lang)

      else:
         next = ' '

      playerlist = ['%s%s. %s' % ('' if loop_userid == userid else '->', x + 1, name) for x, (name, loop_userid) in enumerate(player['playerlist'][player['index']:player['index'] + 7])]

      popup.send(userid, 0, '\n'.join([lang_text('select player', lang=player_lang), ' '] +
         (playerlist if playerlist and self.in_round else [lang_text('empty', lang=player_lang)]) +
         [' ', '8. ' + lang_text('back', lang=player_lang), next, '0. ' + lang_text('cancel', lang=player_lang)]), self.playerMenuSelect)

   def playerMenuSelect(self, userid, item):
      if userid not in self.popups: return

      player     = self.popups[userid]
      selection  = player['index'] + item - 1
      playerlist = player['playerlist']

      if 1 <= item <= 7 and selection < len(playerlist):
         targetid = playerlist[selection][1]
         target   = self.getPlayer(targetid)
         if not target.isDead():
            if player['type'] == 'respawn':
               if es.getplayerteam(targetid) == self.zombieteam:
                  target._newLocation()

            elif player['type'] == 'zombify':
               if es.getplayerteam(targetid) == self.humanteam:
                  self.spawnZombie(targetid)
                  self._checkWin()

         del self.popups[userid]

      elif item == 8:
         if player['index']:
            player['index'] -= 7
            self.sendPlayerMenu(userid)

         else:
            del self.popups[userid]
            self.sendMenu(userid)

      elif item == 9:
         if player['index'] + 7 < len(playerlist):
            player['index'] += 7
            self.sendPlayerMenu(userid)

         elif player['type'] == 'zombify' and len(playerlist) > 1:
            self._createZombies(1)
            del self.popups[userid]

         else:
            del self.popups[userid]
            return True

      else:
         del self.popups[userid]
         return True

      return False

cz = CheapZombieManager()


def endround_cmd():
   """
   cheapzombie_endround
   """
   if es.getargc() == 1:
      cz._cancelRoundEnd()
      cz._forceRoundEnd()

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_endround')

if not es.exists('command', 'cheapzombie_endround'):
   es.regcmd('cheapzombie_endround', 'cheapzombie/endround_cmd', 'cheapzombie_endround\nServer comand for ending the CheapZombie round')


def sendmenu_cmd():
   userid = es.getcmduserid()
   if czauth.isAuthed(userid):
      cz.sendMenu(userid)

   else:
      es.tell(userid, '#multi', lang_text('not authed', lang=playerlib.getPlayer(userid).get('lang')))


###


def getLangText():
   lang_path = es.getAddonPath(info.basename) + '/%s_languages.ini' % info.basename
   if os.path.isfile(lang_path):
      return langlib.Strings(lang_path)

   else:
      es.dbgmsg(0, '%(name)s: Unable to load %(basename)s_languages.ini! Please ensure it is in the ./%(basename)s/ directory.' % {'name':info.name, 'basename':info.basename})
      return lambda x, y, z: '%s: %s_languages.ini not found' % (info.name, info.basename)

lang_text = getLangText()


def remove_tags(text):
   """Removes #lightgreen, #green and #default tags from the supplied string"""
   return text.replace('#lightgreen', '').replace('#green', '').replace('#default', '')


###


say_command = None


def load():
   """
   Ensures critical server variables are created by the config
   """
   global say_command

   config.execute()

   testcmd = str(cvar_trigger)
   if not es.exists('saycommand', testcmd) and testcmd.lower() <> 'none':
      es.regsaycmd(testcmd, 'cheapzombie/sendmenu_cmd', 'Say command to display CheapZombie admin menu')
      say_command = testcmd

   cz._loadEvents()
   cz.mapStart()

   zombiesounds.markSoundsForDownload()

   spawnpoints.roundStart()

   for userid in filter(lambda x: not es.getplayerprop(x, 'CBasePlayer.pl.deadflag'), es.getUseridList()):
      cz.playerSpawn(userid)
   cz.roundStart()


def es_map_start(event_var):
   popup.clearPlayers()
   cz.mapStart()

   zombiesounds.markSoundsForDownload()


def round_start(event_var):
   spawnpoints.roundStart()


def round_freeze_end(event_var):
   cz.roundStart()


def round_end(event_var):
   cz.roundEnd()
   cz._cancelRoundEnd()


def player_spawn(event_var):
   if int(event_var['es_userteam']) > 1:
      cz.playerSpawn(int(event_var['userid']))


def player_hurt(event_var):
   cz.getPlayer(event_var['userid']).playerHurt(int(event_var['attacker']), int(event_var['dmg_health']))


def player_death(event_var):
   cz.playerDeath(int(event_var['userid']))


def player_disconnect(event_var):
   userid = event_var['userid']
   cz.removePlayer(userid)
   cz.removePopup(userid)
   cz._removeIdleWeapons()

   popup.removePlayer(userid)


def item_pickup(event_var):
   cz.getPlayer(event_var['userid']).itemPickup(event_var['item'])


def unload():
   spawnpoints.removeDelay()
   popup.clearPlayers(True)

   cz.roundEnd()
   cz._cancelRoundEnd()

   if say_command:
      es.unregsaycmd(say_command)

   for cvar in config.getCvars():
      es.ServerVar(cvar).set(0)


###


def zombify_cmd():
   """
   cheapzombie_zombify <target userid/\"name\"/\"Steam ID\"> [attacker userid/\"name\"/\"Steam ID\"]
   """
   argc = es.getargc()
   if argc in (2, 3):
      argv     = es.getargv(1)
      targetid = es.getuserid(argv)
      if targetid:
         if not cz.getPlayer(targetid).isDead() and es.getplayerteam(targetid) == cz.humanteam:
            if argc == 3:
               argv       = es.getargv(2)
               attackerid = es.getuserid(argv)

            else:
               attackerid = 0

            if attackerid or argc == 2:
               cz.spawnZombie(targetid, attackerid)

            else:
               es.dbgmsg(0, 'CheapZombie: Unable to find player \"%s\"' % argv)

         else:
            es.dbgmsg(0, 'CheapZombie: Target player \"%s\" is not a living, human player' % argv)

      else:
         es.dbgmsg(0, 'CheapZombie: Unable to find player \"%s\"' % argv)

   else:
      es.dbgmsg(0, 'Syntax: cheapzombie_zombify <target userid/\"name\"/\"Steam ID\"> [attacker userid/\"name\"/\"Steam ID\"]')

if not es.exists('command', 'cheapzombie_zombify'):
   es.regcmd('cheapzombie_zombify', 'cheapzombie/zombify_cmd', 'cheapzombie_zombify <target userid/\"name\"/\"Steam ID\"> [attacker userid/\"name\"/\"Steam ID\"]\nServer command for turning human players into zombies')


###


class CheapPopup(object):
   class Player(object):
      menu     = ()
      callback = None
      timeout  = None

      def __init__(self, userid, parent):
         self.userid = userid
         self.parent = parent

      def send(self, duration, text, callback=None, timeout=None):
         if not self.menu:
            es.menu(0, self.userid, ' ')
            es.cexec(self.userid, 'slot10')

         self.menu     = (duration, self.userid, text)
         self.callback = callback
         self.timeout  = timeout

      def unSend(self):
         if not self.menu:
            es.cexec(self.userid, 'slot10')

         self.removeDelay()
         self.parent.removePlayer(self.userid)

      def selection(self, item):
         if item == 10 and self.menu:
            es.menu(*self.menu)

            delay = self.menu[0]
            if delay:
               gamethread.delayedname(delay, self.parent.basename + '_popup_' + str(self.userid), self._endDelay)

            self.menu = ()
            return

         self.parent.removePlayer(self.userid)

         if self.callback(self.userid, item) if self.callback else True:
            if item <> 10:
               es.cexec(self.userid, 'slot%s' % item)

      def _endDelay(self):
         self.parent.removePlayer(self.userid)
         if self.timeout:
            self.timeout(self.userid)

      def removeDelay(self):
         gamethread.cancelDelayed(self.parent.basename + '_popup_' + str(self.userid))

   """ Begin CheapPopup """
   basename = __name__

   def __init__(self):
      self.players = {}

   """ Player functions """

   def getPlayer(self, userid):
      userid = int(userid)
      if userid not in self.players:
         self.players[userid] = self.Player(userid, self)
         es.addons.registerClientCommandFilter(self._selection_hook)

      return self.players[userid]

   def removePlayer(self, userid):
      userid = int(userid)
      if userid in self.players:
         self.players[userid].removeDelay()
         del self.players[userid]

   def clearPlayers(self, unsend=False):
      if unsend:
         for userid in self.players.keys():
            self.players[userid].unSend()

      else:
         for userid in self.players:
            self.players[userid].removeDelay()

         self.players.clear()

      es.addons.unregisterClientCommandFilter(self._selection_hook)

   """ Popup functions """

   def send(self, userid, duration, text, callback=None, timeout=None):
      self.getPlayer(userid).send(duration, text, callback, timeout)

   def unsend(self, userid):
      userid = int(userid)
      if userid in self.players:
         self.getPlayer(userid).unSend()

   def _selection_hook(self, userid, args):
      if userid in self.players and args[0].lower() == 'menuselect' and len(args) > 1:
         self.getPlayer(userid).selection(int(args[1]))

      return True

popup = CheapPopup()